import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
plt.rcParams["figure.figsize"] = (5, 5)

import sklearn.decomposition
import sklearn.cluster
import sklearn.model_selection
import sklearn.linear_model
import collections


df = pd.read_csv("fer_features_dataset_incomplete.csv")

# dropping samples without teeth, but is it good idea?
df = df.dropna()

df = df.apply(lambda row: row[df['label'].isin(['happiness', 'neutral'])])

np_Y, labels_Y = pd.factorize(df["label"]) # labels, some are missing! How we could recover them?
list_Y = list(np_Y)

# find which emotions need which features
df_scalar = df[['lips_a_h_x1', 'lips_a_h_y1', 'lips_b_h_x1', 'lips_b_h_y1']]
print(df_scalar.describe(include='all'))

np_X = np.array(df_scalar)
# what should we do here?

pca = sklearn.decomposition.PCA(n_components=2)
np_z = pca.fit_transform(np_X)

plt.clf()
plt.cla()
plt.title('Samples by label')
scatter = plt.scatter(
    np_z[:, 0],
    np_z[:, 1],
    c=list_Y,
    cmap='Set1'
)
plt.legend(handles=scatter.legend_elements()[0], labels=list(labels_Y))
plt.show()


def model(X):
    # TODO implement this function so that it would predict emotion label for dataset which you do not have access now
    # could based on clusters, learnable rules or neural network
    Y_prim = ['neutral'] * len(X) # happiness, anger, sadness, neutral
    return Y_prim